Attribute VB_Name = "PropellentApiForVb6"
Option Explicit

' .---------------------------------------------------------------------------.
' |     Subroutines                                                           |
' `---------------------------------------------------------------------------'

Private Declare Sub Vb6DownloadToPropeller _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6DOWNLOADTOPROPELLER" _
  ( _
    ByVal filename As String, _
    ByVal downloadCommand As Long _
  )

Private Declare Sub Vb6FinalizePropellent _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6FINALIZEPROPELLENT" _
  ( _
  )

Private Declare Sub Vb6InitPropellent _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6INITPROPELLENT" _
  ( _
    ByVal hWnd As Long, _
    ByVal storePrefs As Long, _
    ByVal registryPath As String _
  )

Private Declare Sub Vb6SetLibraryPath _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6SETLIBRARYPATH" _
  ( _
    ByVal libraryPath As String _
  )

Private Declare Sub Vb6SetResetSignal _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6SETRESETSIGNAL" _
  ( _
    ByVal resetValue As Long _
  )

Private Declare Sub Vb6SetSerialSearchMethod _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6SETSERIALSEARCHMETHOD" _
  ( _
    ByVal searchMethod As Long _
  )

Private Declare Sub Vb6SetSerialSearchRules _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6SETSERIALSEARCHRULES" _
  ( _
    ByVal serialSearchRules As String _
  )

Private Declare Sub Vb6ShowEditPorts _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6SHOWEDITPORTS" _
  ( _
  )

' .---------------------------------------------------------------------------.
' |     Functions                                                             |
' `---------------------------------------------------------------------------'

Private Declare Function Vb6CompileSource _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6COMPILESOURCE" _
  ( _
    ByVal filename As String, _
    ByVal showError As Long _
  ) As String

Private Declare Function Vb6CompileSourceDocs _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6COMPILESOURCEDOCS" _
  ( _
    ByVal filename As String _
  ) As String

Private Declare Function Vb6GetLibraryPath _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6GETLIBRARYPATH" _
  ( _
  ) As String

Private Declare Function Vb6GetLibraryVersion _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6GETLIBRARYVERSION" _
  ( _
  ) As Long

Private Declare Function Vb6GetPorts _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6GETPORTS" _
  ( _
    ByVal scannable As Long _
  ) As String

Private Declare Function Vb6GetPropellentForVb6Version _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6GETPROPELLENTFORVB6VERSION" _
  ( _
  ) As String

Private Declare Function Vb6GetPropellerVersion _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6GETPROPELLERVERSION" _
  ( _
  ) As Long

Private Declare Function Vb6GetResetSignal _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6GETRESETSIGNAL" _
  ( _
  ) As Long

Private Declare Function Vb6GetSerialSearchMethod _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6GETSERIALSEARCHMETHOD" _
  ( _
  ) As Long

Private Declare Function Vb6GetSerialSearchRules _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6GETSERIALSEARCHRULES" _
  ( _
  ) As String

Private Declare Function Vb6GetSourceHierarchy _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6GETSOURCEHIERARCHY" _
  ( _
  ) As String

Private Declare Function Vb6SaveImage _
  Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
  Alias "VB6SAVEIMAGE" _
  ( _
    ByVal saveAsBinary As Long, _
    ByVal filename As String, _
    ByVal showSaveAs As Long _
  ) As Long

Public Sub DownloadToPropeller _
  ( _
    ByVal filename As String, _
    ByVal downloadCommand As Long _
  )
  Call Vb6DownloadToPropeller(filename, downloadCommand)
End Sub

Public Sub FinalizePropellent()
  Call Vb6FinalizePropellent
End Sub

Public Sub InitPropellent _
  ( _
    ByVal hWnd As Long, _
    ByVal storePrefs As Boolean, _
    ByVal registryPath As String _
  )
  Call Vb6InitPropellent(hWnd, storePrefs, registryPath)
End Sub

Public Sub SetLibraryPath _
  ( _
    ByVal libraryPath As String _
  )
  Call Vb6SetLibraryPath(libraryPath)
End Sub

Public Sub SetResetSignal _
  ( _
    ByVal resetValue As Long _
  )
  Call Vb6SetResetSignal(resetValue)
End Sub

Public Sub SetSerialSearchMethod _
  ( _
    ByVal searchMethod As Long _
  )
  Call Vb6SetSerialSearchMethod(searchMethod)
End Sub

Public Sub SetSerialSearchRules _
  ( _
    ByVal serialSearchRules As String _
  )
  Call Vb6SetSerialSearchRules(serialSearchRules)
End Sub

Public Sub ShowEditPorts()
  Call Vb6ShowEditPorts
End Sub
Public Function CompileSource _
  ( _
    ByVal filename As String, _
    ByVal showError As Boolean _
  ) As String
  CompileSource = Vb6CompileSource(filename, showError)
End Function

Public Function CompileSourceDocs _
  ( _
    ByVal filename As String _
  ) As String
  CompileSourceDocs = Vb6CompileSourceDocs(filename)
End Function

Public Function GetLibraryPath() As String
  GetLibraryPath = Vb6GetLibraryPath
End Function

Public Function GetLibraryVersion() As Long
  GetLibraryVersion = Vb6GetLibraryVersion
End Function
Public Function GetLibraryVersionText() As String
Dim versionText As String
  versionText = Hex$(GetLibraryVersion)
  GetLibraryVersionText = Left$(versionText$, Len(versionText$) - 1) _
                        + "." _
                        + Right$(versionText$, 1)
End Function
Public Function GetPorts _
  ( _
    ByVal scannable As Boolean _
  ) As String
  GetPorts = Vb6GetPorts(scannable)
End Function

Public Function GetPropellentForVb6Version() As String
  GetPropellentForVb6Version = Vb6GetPropellentForVb6Version
End Function

Public Function GetPropellerVersion() As Long
  GetPropellerVersion = Vb6GetPropellerVersion
End Function

Public Function GetResetSignal() As Long
  GetResetSignal = Vb6GetResetSignal
End Function

Public Function GetSerialSearchMethod() As Long
  GetSerialSearchMethod = Vb6GetSerialSearchMethod
End Function

Public Function GetSerialSearchRules() As String
  GetSerialSearchRules = Vb6GetSerialSearchRules
End Function

Public Function GetSourceHierarchy() As String
  GetSourceHierarchy = Vb6GetSourceHierarchy
End Function

Public Function SaveImage _
  ( _
    ByVal saveAsBinary As Boolean, _
    ByVal filename As String, _
    ByVal showSaveAs As Boolean _
  ) As Long
  SaveImage = Vb6SaveImage(saveAsBinary, filename, showSaveAs)
End Function


