
' *****************************************************************************
' *                                                                           *
' *     AiChip PropellentForVb6 DLL Source Code ( PB/Win 7.02 )               *
' *                                                                           *
' *****************************************************************************
' *                                                                           *
' *     Project        : AiChip VB6 DLL Wrapper for Parallax Propellent DLL   *
' *                                                                           *
' *     Version        : 1.00                                                 *
' *     Created        : 2008-06-01                                           *
' *                                                                           *
' *     Author         : AiChip Industries                                    *
' *                                                                           *
' *     Copyright      : 2008, AiChip Industries                              *
' *                                                                           *
' *     Compiler Used  : PowerBasic PB/Win 7.02                               *
' *                                                                           *
' *     License        : MIT License. Please see end of this file for Terms   *
' *                      of Use.                                              *
' *                                                                           *
' *****************************************************************************
' *                                                                           *
' *     AiChip is a trademark of AiChip Industries.                           *
' *                                                                           *
' *     If distributing a modified version of this software AiChip Industries *
' *     requests all "AiChip" references be removed from the filename and     *
' *     internal text descriptions to avoid any confusion that may be caused  *
' *     by an impression that the modified software originates from AiChip    *
' *     Industries.                                                           *
' *                                                                           *
' *****************************************************************************

#COMPILE DLL

' *****************************************************************************
' *                                                                           *
' *     Interface presented by Parallax Propellent.Dll                        *
' *                                                                           *
' *****************************************************************************

' .---------------------------------------------------------------------------.
' |     Subroutines                                                           |
' `---------------------------------------------------------------------------'

DECLARE SUB DownloadToPropeller CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "DownloadToPropeller" _
  ( _
    BYVAL filename AS STRING, _
    BYVAL downloadCommand AS LONG _
  )

DECLARE SUB FinalizePropellent CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "FinalizePropellent" _
  ( _
  )

DECLARE SUB InitPropellent CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "InitPropellent" _
  ( _
    BYVAL hWnd AS LONG, _
    BYVAL storePrefs AS LONG, _
    BYVAL registryPath AS STRING _
  )

DECLARE SUB SetLibraryPath CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "SetLibraryPath" _
  ( _
    BYVAL libraryPath AS STRING _
  )

DECLARE SUB SetResetSignal CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "SetResetSignal" _
  ( _
    BYVAL resetValue AS BYTE _
  )

DECLARE SUB SetSerialSearchMethod CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "SetSerialSearchMethod" _
  ( _
    BYVAL searchMethod AS LONG _
  )

DECLARE SUB SetSerialSearchRules CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "SetSerialSearchRules" _
  ( _
    BYVAL serialSearchRules AS STRING _
  )

DECLARE SUB ShowEditPorts CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "ShowEditPorts" _
  ( _
  )

' .---------------------------------------------------------------------------.
' |     Functions                                                             |
' `---------------------------------------------------------------------------'

DECLARE FUNCTION CompileSource CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "CompileSource" _
  ( _
    BYVAL filename AS STRING, _
    BYVAL showError AS LONG _
  ) AS STRING

DECLARE FUNCTION CompileSourceDocs CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "CompileSourceDocs" _
  ( _
    BYVAL filename AS STRING _
  ) AS STRING

DECLARE FUNCTION GetLibraryPath CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "GetLibraryPath" _
  ( _
  ) AS STRING

DECLARE FUNCTION GetLibraryVersion CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "GetLibraryVersion" _
  ( _
  ) AS LONG

DECLARE FUNCTION GetPorts CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "GetPorts" _
  ( _
    BYVAL scannable AS LONG _
  ) AS STRING

DECLARE FUNCTION GetPropellerVersion CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "GetPropellerVersion" _
  ( _
  ) AS LONG

DECLARE FUNCTION GetResetSignal CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "GetResetSignal" _
  ( _
  ) AS BYTE

DECLARE FUNCTION GetSerialSearchMethod CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "GetSerialSearchMethod" _
  ( _
  ) AS LONG

DECLARE FUNCTION GetSerialSearchRules CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "GetSerialSearchRules" _
  ( _
  ) AS STRING

DECLARE FUNCTION GetSourceHierarchy CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "GetSourceHierarchy" _
  ( _
  ) AS STRING

DECLARE FUNCTION SaveImage CDECL _
  LIB "C:\Vb\User\Propellent\Propellent.Dll" _
  ALIAS "SaveImage" _
  ( _
    BYVAL saveAsBinary AS LONG, _
    BYVAL filename AS STRING, _
    BYVAL showSaveAs AS LONG _
  ) AS LONG

' *****************************************************************************
' *                                                                           *
' *     Interface presented to VB6                                            *
' *                                                                           *
' *****************************************************************************

' .---------------------------------------------------------------------------.
' |     Subroutines                                                           |
' `---------------------------------------------------------------------------'

SUB Vb6DownloadToPropeller( _
                            BYVAL filename        AS STRING, _
                            BYVAL downloadCommand AS LONG    _
                          ) EXPORT
END SUB

SUB Vb6FinalizePropellent() EXPORT
  CALL FinalizePropellent()
END SUB

SUB Vb6InitPropellent( BYVAL hWnd         AS LONG,  _
                       BYVAL storePrefs   AS LONG,  _
                       BYVAL registryPath AS STRING _
                     ) EXPORT
  CALL InitPropellent( hWnd, storePrefs <> 0, registryPath )
END SUB

SUB Vb6SetLibraryPath( BYVAL libraryPath AS STRING ) EXPORT
  CALL SetLibraryPath( libraryPath )
END SUB

SUB Vb6SetResetSignal( BYVAL resetValue AS LONG ) EXPORT
  CALL SetResetSignal( resetValue )
END SUB

SUB Vb6SetSerialSearchMethod( BYVAL serialSearchMethod AS LONG ) EXPORT
  CALL SetSerialSearchMethod( serialSearchMethod )
END SUB

SUB Vb6SetSerialSearchRules( BYVAL serialSearchRules AS STRING ) EXPORT
  CALL SetSerialSearchRules( serialSearchRules )
END SUB

SUB Vb6ShowEditPorts() EXPORT
  CALL ShowEditPorts
END SUB

' .---------------------------------------------------------------------------.
' |     Functions                                                             |
' `---------------------------------------------------------------------------'

FUNCTION Vb6CompileSource( BYVAL filename  AS STRING, _
                           BYVAL showError AS LONG    _
                         ) EXPORT AS STRING
  FUNCTION = CompileSource( filename, showError <> 0 )
END FUNCTION

FUNCTION Vb6CompileSourceDocs( BYVAL filename AS STRING )EXPORT AS STRING
  FUNCTION = CompileSourceDocs( filename )
END FUNCTION

FUNCTION Vb6GetLibraryPath() EXPORT AS STRING
  FUNCTION = GetLibraryPath
END FUNCTION

FUNCTION Vb6GetLibraryVersion() EXPORT AS LONG
  FUNCTION = GetLibraryVersion
END FUNCTION

FUNCTION Vb6GetPorts( BYVAL scannable AS LONG ) EXPORT AS STRING
  FUNCTION = GetPorts( scannable <> 0 )
END FUNCTION

FUNCTION Vb6GetPropellentForVb6Version() EXPORT AS STRING
  FUNCTION = "AiChip VB6 DLL Wrapper for Parallax Propellent DLL" + CHR$(&hD) + CHR$(&hA) _
           + "Version 1.00" + CHR$(&hD) + CHR$(&hA) _
           + "(C) 2008, AiChip Industries"
END FUNCTION

FUNCTION Vb6GetPropellerVersion() EXPORT AS LONG
  FUNCTION = GetPropellerVersion
END FUNCTION

FUNCTION Vb6GetResetSignal() EXPORT AS LONG
  FUNCTION = GetResetSignal
END FUNCTION

FUNCTION Vb6GetSerialSearchMethod() EXPORT AS LONG
  FUNCTION = GetSerialSearchMethod
END FUNCTION

FUNCTION Vb6GetSerialSearchRules() EXPORT AS STRING
  FUNCTION = GetSerialSearchRules$
END FUNCTION

FUNCTION Vb6GetSourceHierarchy() EXPORT AS STRING
  FUNCTION = GetSourceHierarchy$
END FUNCTION

FUNCTION Vb6SaveImage( BYVAL saveAsBinary AS LONG,   _
                       BYVAL filename     AS STRING, _
                       BYVAL showSaveAs   AS LONG    _
                     ) EXPORT AS LONG
  FUNCTION = SaveImage( saveAsBinary <> 0, filename, showSaveAs <> 0 )
END FUNCTION

' *****************************************************************************
' *                                                                           *
' *     API Definitions used by VB6                                           *
' *                                                                           *
' *****************************************************************************

'  Option Explicit
'
' .---------------------------------------------------------------------------.
' |     Subroutines                                                           |
' `---------------------------------------------------------------------------'
'
'  Private Declare Sub Vb6DownloadToPropeller _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6DOWNLOADTOPROPELLER" _
'    ( _
'      ByVal filename As String, _
'      ByVal downloadCommand As Long _
'    )
'
'  Private Declare Sub Vb6FinalizePropellent _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6FINALIZEPROPELLENT" _
'    ( _
'    )
'
'  Private Declare Sub Vb6InitPropellent _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6INITPROPELLENT" _
'    ( _
'      ByVal hWnd As Long, _
'      ByVal storePrefs As Long, _
'      ByVal registryPath As String _
'    )
'
'  Private Declare Sub Vb6SetLibraryPath _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6SETLIBRARYPATH" _
'    ( _
'      ByVal libraryPath As String _
'    )
'
'  Private Declare Sub Vb6SetResetSignal _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6SETRESETSIGNAL" _
'    ( _
'      ByVal resetValue As Long _
'    )
'
'  Private Declare Sub Vb6SetSerialSearchMethod _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6SETSERIALSEARCHMETHOD" _
'    ( _
'      ByVal searchMethod As Long _
'    )
'
'  Private Declare Sub Vb6SetSerialSearchRules _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6SETSERIALSEARCHRULES" _
'    ( _
'      ByVal serialSearchRules As String _
'    )
'
'  Private Declare Sub Vb6ShowEditPorts _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6SHOWEDITPORTS" _
'    ( _
'    )
'
' .---------------------------------------------------------------------------.
' |     Functions                                                             |
' `---------------------------------------------------------------------------'
'
'  Private Declare Function Vb6CompileSource _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6COMPILESOURCE" _
'    ( _
'      ByVal filename As String, _
'      ByVal showError As Long _
'    ) As String
'
'  Private Declare Function Vb6CompileSourceDocs _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6COMPILESOURCEDOCS" _
'    ( _
'      ByVal filename As String _
'    ) As String
'
'  Private Declare Function Vb6GetLibraryPath _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6GETLIBRARYPATH" _
'    ( _
'    ) As String
'
'  Private Declare Function Vb6GetLibraryVersion _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6GETLIBRARYVERSION" _
'    ( _
'    ) As Long
'
'  Private Declare Function Vb6GetPorts _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6GETPORTS" _
'    ( _
'      ByVal scannable As Long _
'    ) As String
'
'  Private Declare Function Vb6GetPropellentForVb6Version _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6GETPROPELLENTFORVB6VERSION" _
'    ( _
'    ) As String
'
'  Private Declare Function Vb6GetPropellerVersion _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6GETPROPELLERVERSION" _
'    ( _
'    ) As Long
'
'  Private Declare Function Vb6GetResetSignal _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6GETRESETSIGNAL" _
'    ( _
'    ) As Long
'
'  Private Declare Function Vb6GetSerialSearchMethod _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6GETSERIALSEARCHMETHOD" _
'    ( _
'    ) As Long
'
'  Private Declare Function Vb6GetSerialSearchRules _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6GETSERIALSEARCHRULES" _
'    ( _
'    ) As String
'
'  Private Declare Function Vb6GetSourceHierarchy _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6GETSOURCEHIERARCHY" _
'    ( _
'    ) As String
'
'  Private Declare Function Vb6SaveImage _
'    Lib "C:\Vb\User\Propellent\PropellentForVb6.Dll" _
'    Alias "VB6SAVEIMAGE" _
'    ( _
'      ByVal saveAsBinary As Long, _
'      ByVal filename As String, _
'      ByVal showSaveAs As Long _
'    ) As Long

' *****************************************************************************
' *                                                                           *
' *     Terms of Use : MIT License                                            *
' *                                                                           *
' *****************************************************************************
'
' Permission is hereby granted, free of charge, to any person obtaining a copy
' of this software and associated documentation files (the "Software"), to deal
' in the Software without restriction, including without limitation the rights
' to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
' copies of the Software, and to permit persons to whom the Software is
' furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in
' all copies or substantial portions of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
' IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
' FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
' AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
' LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
' OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
' SOFTWARE.

' *****************************************************************************
' *                                                                           *
' *     End of PropellentForVb6 DLL Source Code                               *
' *                                                                           *
' *****************************************************************************
